from .cityfibre import CFChecker
from .openreach import ORChecker
from .virginmedia import VMChecker
from .truespeed import TSChecker
from .gigaclear import GCChecker
from .ofnl import OFNLChecker
from .jurassicfibre import JFChecker
from .communityfibre import CommunityFibreChecker
from .trooli import TrooliChecker
from .zzoomm import ZzoommChecker
from .toob import ToobChecker
from .heybroadband import HeyBroadbandChecker
from .wessexinternet import WessexInternetChecker
from .technological import TechnologicalChecker
from .glide import GlideChecker
from .swishfibre import SwichFibreChecker
from .gnetwork import GNetworkChecker
from .kcom import KComChecker
from .pinemedia import PineMediaChecker
from .youfibre import YouFibreChecker

def UKBroadbandChecker(name, **args):
    checkers = UKBroadbandCheckerModes()
    if name not in checkers:
        raise ValueError(f"{name} is not a valid UK broadband checker")
    return checkers[name](**args)

def UKBroadbandCheckerModes():
    return {
        'cityfibre': CFChecker,
        'virgin-media': VMChecker,
        'openreach': ORChecker,
        'truespeed': TSChecker,
        'gigaclear': GCChecker,
        'ofnl': OFNLChecker,
        'jurassic-fibre': JFChecker,
        'community-fibre': CommunityFibreChecker,
        'trooli': TrooliChecker,
        'zzoomm': ZzoommChecker,
        'toob': ToobChecker,
        'hey-broadband': HeyBroadbandChecker,
        'wessex-internet': WessexInternetChecker,
        'technological': TechnologicalChecker,
        'glide': GlideChecker,
        'swish-fibre': SwichFibreChecker,
        'gnetwork': GNetworkChecker,
        'kcom': KComChecker,
        'pine-media': PineMediaChecker,
        'youfibre': YouFibreChecker,
    }

def UKBroadbandCheckerCompanyNames():
    return {
        'cityfibre': 'CityFibre',
        'virgin-media': 'Virgin Media',
        'openreach': 'Openreach',
        'truespeed': 'Truespeed',
        'gigaclear': 'Gigaclear',
        'ofnl': 'OFNL',
        'jurassic-fibre': 'Jurassic Fibre',
        'community-fibre': 'Community Fibre',
        'trooli': 'Trooli',
        'zzoomm': 'Zzoomm',
        'toob': 'toob',
        'hey-broadband': 'Hey!Broadband',
        'wessex-internet': 'Wessex Internet',
        'technological': 'Technological',
        'glide': 'Glide',
        'swish-fibre': 'Swish Fibre',
        'gnetwork': "G.Network",
        'kcom': "KCom",
        'pine-media': "Pine Media",
        'youfibre': "YouFibre",
    }
