# The addresses array that should be passed should have the following format:
# [
#   {
#     "addressLine": "9 Ashcombe Rd, Weston-super-Mare BS23 3DS",
#     "returnValue": "whatever",
#   },
#   ...
# ]
# The function will loop over the array to find the most likely match in
# "addressLine", and then return the "returnValue" in that dict along with
# true.
# If the function is uncertain, it'll return the first result and the second
# truple value will be false.

def UKBroadbandAddressMatcher(houseNumber, postcode, addressArray):
    houseNumber = f"{houseNumber}".lower()
    for thisAddress in addressArray:
        if thisAddress['addressLine'].startswith(f'{houseNumber} '):
            return thisAddress['returnValue'], True
        elif thisAddress['addressLine'].startswith(f'{houseNumber}, '):
            return thisAddress['returnValue'], True
        elif thisAddress['addressLine'].lower() == houseNumber:
            return thisAddress['returnValue'], True

    return addressArray[0]['returnValue'], False
