import requests
import json
from .resultclass import BroadbandResult

class GlideChecker:
    def __init__(
        self,
        checkerAddress="https://glidegroup.co.uk/perch/request.php",
    ):
        self.checkerAddress = checkerAddress


    def query_address(self, postCode, houseNumber, strictAddress=True):
        postCode = ''.join(ch for ch in postCode if ch.isalnum())

        checker = requests.get(
            f'{self.checkerAddress}',
            params={
                "postcode": postCode,
            }
        )

        result = json.loads(checker.text)

        returnData = {
            'serviceable': False,
            'planned': False,
            'success': False,
            'message': result,
        }

        if result["status"] == "Query Successful":
            returnData['success'] = True

            if result["premises_warwicknet_live"] > 0:
                returnData['serviceable'] = True
            elif result["premises_warwicknet_comingsoon"] > 0:
                returnData['planned'] = True

        returnResult = BroadbandResult(
            data=returnData,
        )
        returnResult.fttp = returnData['serviceable']

        return returnResult
