import requests
import json
from .resultclass import BroadbandResult

class KComChecker:
    def __init__(
        self,
        checkerAddress="https://api.digital.kcom.com/kcom-api/kcom-shop-api/checkouts/helpers/servicecheck",
    ):
        self.checkerAddress = checkerAddress


    def query_address(self, postCode, houseNumber, strictAddress=True):
        postCode = ''.join(ch for ch in postCode if ch.isalnum())
        postCode=f"{postCode[:-3]} {postCode[-3:]}"

        checker = requests.get(
            f'{self.checkerAddress}',
            params={
                "postcode": postCode,
                "houseNumber": houseNumber,
            },
            headers={
                'User-Agent': 'bidb.uk',
            },
        )
        checkerData = json.loads(checker.text)

        returnData = {
            'addressdata': checkerData,
            'serviceable': False,
            'fttp': False,
            'success': True,
        }

        if checkerData['deliverable']:
            returnData = {
                'addressdata': checkerData,
                'serviceable': True,
                'fttp': True,
                'success': True,
            }

        return BroadbandResult(
            data=returnData,
        )
