import requests
from bs4 import BeautifulSoup
from .resultclass import BroadbandResult

class OFNLChecker:
    def __init__(
        self,
        checkerAddress="https://www.ofnl.co.uk/residents-businesses/postcode-checker",
    ):
        self.checkerAddress = checkerAddress


    def query_address(self, postCode, houseNumber, strictAddress=True):
        session = requests.Session()

        csrf = session.get(
            f'{self.checkerAddress}',
        )
        soup = BeautifulSoup(csrf.text, 'html.parser')
        token = soup.find("input", {"name":"csrf"}).get('value')

        checker = session.post(
            f'{self.checkerAddress}',
            data={
                "OUTCODE": postCode[:-3],
                "INCODE": postCode[-3:],
                "csrf": token,
            }
        )
        soup = BeautifulSoup(checker.text, 'html.parser')
        result = soup.find("h3").text

        returnData = {
            'serviceable': False,
            'success': False,
            'message': result,
        }

        if result == "Sorry":
            returnData.update({
                'success': True,
            })
        elif result == "Good News":
            returnData.update({
                'serviceable': True,
                'success': True,
            })

        returnResult = BroadbandResult(
            data=returnData,
        )
        returnResult.fttp = returnData['serviceable']

        return returnResult
