import requests
import json
import string
from .resultclass import BroadbandResult

class TechnologicalChecker:
    def __init__(
        self,
        checkerAddress="http://www.technological.co.uk/wp-admin/admin-ajax.php",
        checkerList="EX16",
    ):
        self.checkerAddress = checkerAddress
        self.checkerList = checkerList


    def query_address(self, postCode, houseNumber, strictAddress=True):
        postCode = ''.join(ch for ch in postCode if ch.isalnum())
        postCode=f"{postCode[:-3]} {postCode[-3:]}"

        checker = requests.post(
            f'{self.checkerAddress}',
            data={
                "action": "sapc_ajax_check",
                "pc": postCode,
                "verify": "off",
                "list": self.checkerList,
            }
        )

        result = json.loads(checker.text)

        returnData = {
            'serviceable': False,
            'success': False,
            'message': result["1"],
        }

        if result["0"] == "Error":
            returnData.update({
                'success': True,
            })
        elif result["0"] == "Success":
            returnData.update({
                'serviceable': True,
                'success': True,
            })

        returnResult = BroadbandResult(
            data=returnData,
        )
        returnResult.fttp = returnData['serviceable']

        return returnResult
